﻿package 
{
	public class DodgeState implements State
	{
		private var enemy:Enemy;
		
		private var theta:Number;
		private var dTheta:Number;
		
		private var framesInState:int;
		
		public function DodgeState(e:Enemy):void
		{
			enemy = e;
		}
		
		public function enter() :void
		{
			framesInState = 0;
			
			//SoundManager.getInstance().playSound(SoundMappings.HUMAN_DODGE);
			
			if (enemy is Human)
			{
				theta = (Math.random() * GameConstants.ENEMY_DODGE_RANGE) + GameConstants.ENEMY_DODGE_START;
			}
			else if (enemy is Car)
			{
				if (enemy.getTheta() == 0)
				{
					dTheta = 2;
				}
				else if (enemy.getTheta() == 180)
				{
					dTheta = -2;
				}
			}
		}
		
		public function update():void
		{
			framesInState++;
			
			if (enemy is Human)
			{
				enemy.setPos(Enemy.getValidPos(Vector2.add(enemy.getPos(), new Vector2(Math.cos(theta) * GameConstants.ENEMY_DODGING_SPEED, Math.sin(theta) * GameConstants.ENEMY_DODGING_SPEED))));
				
				if (framesInState >= GameConstants.HUMAN_DODGE_FRAMES)
				{
					enemy.pause();
				}
			}
			else if (enemy is Car)
			{
				var dir:Vector2;
				
				enemy.setTheta(enemy.getTheta() + dTheta);
				
				theta = (enemy.getTheta() * (Math.PI / 180));
				
				dir = new Vector2(Math.cos(theta) * GameConstants.NORMAL_CAR_SPEED, Math.sin(theta) * GameConstants.NORMAL_CAR_SPEED);
				
				enemy.setPos(Enemy.getValidPos(Vector2.add(enemy.getPos(), dir)));
				
				if (enemy.getTheta() == 90)
				{
					enemy.kill();
				}
			}
		}
		
		public function exit():void
		{
			
		}
	}
}