﻿package 
{
	public class PanicState implements State
	{
		private var enemy:Enemy;
		
		private var dir:Vector2;
		
		private var framesInState:int;
		
		public function PanicState(e:Enemy, dir:Vector2):void
		{
			enemy = e;
			
			this.dir = dir;
		}
		
		public function enter():void
		{
			// Get the angle of the panic vector
			var angle:Number = Math.acos(Vector2.dot(dir, new Vector2(1, 0)));
			
			// Get a random angle in the range [-90, 90)
			var error:Number = (Math.random() * Math.PI) - (Math.PI / 2);
			
			// Add the error to the panic angle
			angle += error;
			
			// Get the new panic dir
			dir = new Vector2(Math.cos(angle), Math.sin(angle));
			
			(enemy as Human).excitability--;
			
			(enemy as Human).exciteProb = (enemy as Human).excitability / GameConstants.MAX_EXCITE;
		}
		
		public function update():void
		{
			framesInState++;
			
			enemy.setPos(Enemy.getValidPos(Vector2.add(enemy.getPos(), Vector2.multiply(GameConstants.ENEMY_PANIC_SPEED, dir))));
			
			if (framesInState >= GameConstants.PANIC_LENGTH)
			{
				enemy.pause();
			}
		}
		
		public function exit():void
		{
			
		}
	}
}