﻿package 
{
	public class YellowCarDodgeState extends DodgeState
	{
		private var enemy:Enemy;
		
		private var theta:Number;
		private var dTheta:Number;
		
		private var framesInState:int;
		
		public function YellowCarDodgeState(e:Enemy):void
		{
			super(e);
			
			enemy = e;
		}
		
		public override function enter() :void
		{
			framesInState = 0;
			
			//SoundManager.getInstance().playSound(SoundMappings.HUMAN_DODGE);
			
			if (enemy.getTheta() == 0)
			{
				dTheta = GameConstants.CAR_SWERVE_THETA;
			}
			else if (enemy.getTheta() == 180)
			{
				dTheta = -GameConstants.CAR_SWERVE_THETA;
			}
		}
		
		public override function update():void
		{
			framesInState++;
			
			var dir:Vector2;
				
			enemy.setTheta(enemy.getTheta() + dTheta);
			
			theta = (enemy.getTheta() * (Math.PI / 180));
			
			dir = new Vector2(Math.cos(theta) * GameConstants.NORMAL_CAR_SPEED, Math.sin(theta) * GameConstants.NORMAL_CAR_SPEED);
			
			enemy.setPos(Enemy.getValidPos(Vector2.add(enemy.getPos(), dir)));
			
			if (enemy.getTheta() == 90)
			{
				enemy.kill();
			}
		}
		
		public override function exit():void
		{
			
		}
	}
}