﻿package 
{
	public class Car extends Enemy
	{
		private var hits:int;
		
		public function Car(name:String)
		{
			hits = 0;
			
			super(name);
		}
		
		public override function update():void
		{
			if (this.getPos() == Vector2.Zero)
			{
				this.markForRemoval();
				return;
			}
			
			// Update the state machine
			fsm.update();
			
			//drawBoundingCircle();
			
			EnemyManager.getInstance().collide(this)
			
			//mark as dead if moved off screen
			if ( (this.x < GameConstants.STAGE_LEFT_CAR) || (this.x > GameConstants.STAGE_RIGHT_CAR) )
			{	
				this.markForRemoval();
				this.velocity = new Vector2(0, 0);
			}
		}
		
		public override function hit() 
		{
			if (fsm.getCurrentState() is DodgeState)
			{
				return;
			}
			else
			{
				if (hits < GameConstants.HITS_BEFORE_SWERVE - 1)
				{
					hits++;
				}
				else
				{
					if (!isDodging())
					{
						dodge();
					}
				}
			}
		}
		
		public override function kill()
		{
			if (!(fsm.getCurrentState() is DeadState))
			{
				fsm.changeState(new DeadState(this));
				SoundManager.getInstance().playSound(SoundMappings.HUMAN_DEATH);
			}
		}
	}
}