﻿package 
{
	public class CarFactory
	{
		private static var instance:CarFactory;
		
		public function CarFactory()
		{
		}
		
		public static function getInstance()
		{
			if (instance == null)
			{
				instance = new CarFactory();
			}
			
			return instance;
		}
		
		public function initCar(car:Car)
		{
			var posx:int;
			var posy:int;
			
			// Randomly assign the side of the screen the enemy will start on
			var side:Number = Math.random() * 2 - 1;
			
			// Set the start position and velocity depending on which
			// side of the screen the enemy is starting on
			if (side < 0)
			{
				posx = GameConstants.STAGE_LEFT_CAR;
				posy = GameConstants.LOWER_LANE;
				car.setPos(new Vector2(posx, posy));
				car.velocity = new Vector2(GameConstants.NORMAL_CAR_SPEED, 0);
			}
			else
			{
				car.setTheta(180);
				car.scaleY = -1
				
				posx = GameConstants.STAGE_RIGHT_CAR;
				posy = GameConstants.UPPER_LANE;
				car.setPos(new Vector2(posx, posy));
				car.velocity = new Vector2( -GameConstants.NORMAL_CAR_SPEED, 0);
			}
		}
		
		public function createCar(type:int):Car
		{
			var car:Car;
			
			// Create the correct type of enemy
			switch(type)
			{
				case CarType.YELLOW_CAR: car = new YellowCar(); break;
				case CarType.BEIGE_CAR: car = new BeigeCar(); break;
				case CarType.SPORTS_CAR: car = new SportsCar(); break;
				default: car = new Car(CarType.BEIGE_CAR_NAME);
			}
			
			// Initialize the enemy
			initCar(car);
			
			// Return the new enemy
			return car;
		}
		
		public function createCarLeft(type:int):Car
		{
			var car:Car;
			var posx:int;
			var posy:int;
			
			// Create the correct type of enemy
			switch(type)
			{
				case CarType.YELLOW_CAR: car = new YellowCar(); break;
				case CarType.BEIGE_CAR: car = new BeigeCar(); break;
				case CarType.SPORTS_CAR: car = new SportsCar(); break;
				default: car = new Car(CarType.BEIGE_CAR_NAME);
			}
			
			posx = GameConstants.STAGE_LEFT_CAR;
			posy = GameConstants.LOWER_LANE;
			car.setPos(new Vector2(posx, posy));
			car.velocity = new Vector2(GameConstants.NORMAL_CAR_SPEED, 0);
			
			if (type == CarType.SPORTS_CAR)
			{
				car.velocity = new Vector2( GameConstants.SPORTS_CAR_START_SPEED, 0);
			}
			else
			{
				car.velocity = new Vector2( GameConstants.NORMAL_CAR_SPEED, 0);
			}
			
			// Return the new enemy
			return car;
		}
		
		public function createCarRight(type:int):Car
		{
			var car:Car;
			var posx:int;
			var posy:int;
			
			// Create the correct type of enemy
			switch(type)
			{
				case CarType.YELLOW_CAR: car = new YellowCar(); break;
				case CarType.BEIGE_CAR: car = new BeigeCar(); break;
				case CarType.SPORTS_CAR: car = new SportsCar(); break;
				default: car = new Car(CarType.BEIGE_CAR_NAME);
			}
			
			car.setTheta(180);
			car.scaleY = -1
			
			posx = GameConstants.STAGE_RIGHT_CAR;
			posy = GameConstants.UPPER_LANE;
			car.setPos(new Vector2(posx, posy));
			
			if (type == CarType.SPORTS_CAR)
			{
				car.velocity = new Vector2( -GameConstants.SPORTS_CAR_START_SPEED, 0);
			}
			else
			{
				car.velocity = new Vector2( -GameConstants.NORMAL_CAR_SPEED, 0);
			}
			
			// Return the new enemy
			return car;
		}
	}	
}