﻿package 
{
	public class EnemyFactory
	{
		private static var instance:EnemyFactory;
		
		public function EnemyFactory()
		{
		}
		
		public static function getInstance()
		{
			if (instance == null)
			{
				instance = new EnemyFactory();
			}
			
			return instance;
		}
		
		public function initEnemy(enemy:Enemy, type:int)
		{
			var posx:int;
			var posy:int;
			
			// Randomly assign the side of the screen the enemy will start on
			var side:Number = Math.random() * 2 - 1;
			
			// Set the start position and velocity depending on which
			// side of the screen the enemy is starting on
			if (side < 0)
			{
				if (enemy is Car)
				{
					posx = GameConstants.STAGE_LEFT_CAR;
					posy = GameConstants.LOWER_LANE;
					enemy.setPos(new Vector2(posx, posy));
					enemy.velocity = new Vector2(GameConstants.NORMAL_CAR_SPEED, 0);
				}
				else if (enemy is Human)
				{
					posx = GameConstants.STAGE_LEFT;
					// Randomly assign a starting y-position
					posy = Human.GetRandomY();
					
					enemy.setPos(Human.getValidStartPos(new Vector2(posx, posy)));
					enemy.velocity = new Vector2(GameConstants.ENEMY_WALKING_SPEED, 0);
				}
			}
			else
			{
				enemy.setTheta(180);
				enemy.scaleY = -1
				if (enemy is Car)
				{
					posx = GameConstants.STAGE_RIGHT_CAR;
					posy = GameConstants.UPPER_LANE;
					enemy.setPos(new Vector2(posx, posy));
					enemy.velocity = new Vector2( -GameConstants.NORMAL_CAR_SPEED, 0);
				}
				else if (enemy is Human)
				{
					posx = GameConstants.STAGE_RIGHT;
					// Randomly assign a starting y-position
					posy = Human.GetRandomY();
					
					enemy.setPos(Human.getValidStartPos(new Vector2(posx, posy)));
					enemy.velocity = new Vector2(-GameConstants.ENEMY_WALKING_SPEED, 0);
				}
			}
		}
		
		public function createEnemy(type:int):Enemy
		{
			var enemy:Enemy;
			
			// Create the correct type of enemy
			switch(type)
			{
				case EnemyType.FATTY: enemy = new FatMan(); break;
				case EnemyType.WOMAN: enemy = new Woman(); break;
				case EnemyType.MAN: enemy = new Man(); break;
				default: enemy = new Man();
			}
			
			
			// Initialize the enemy
			initEnemy(enemy, type);
			
			// Return the new enemy
			return enemy;
		}
	}	
}