﻿package 
{
	public class Human extends Enemy
	{
		public var excitability = GameConstants.MAX_EXCITE;
		public var exciteProb:Number;
		
		public function Human(filename:String)
		{
			super(filename);
			
			enemyType = EnemyType.HUMAN;
			
			exciteProb = 1;
		}
		
		public override function update():void
		{
			var dir:Vector2;
			
			// Update the state machine
			fsm.update();
			
			//drawBoundingCircle();
			
			//mark as dead if moved off screen
			if ( (this.x < GameConstants.STAGE_LEFT) || (this.x > GameConstants.STAGE_RIGHT) )
			{	
				this.markForRemoval();
				this.velocity = new Vector2(0, 0);
			}
		}
		
		// Randomly assign a starting y-position
		public static function GetRandomY():int
		{
			return (int)(Math.random() * GameConstants.SIDEWALK_RANGE + GameConstants.SIDEWALK_TOP);
		}
		
		public override function resetSpeed()
		{
			this.velocity.setLength(GameConstants.ENEMY_WALKING_SPEED);
		}
		
		public static function getValidStartPos(testPos:Vector2):Vector2
		{
			if (testPos.y > GameConstants.SIDEWALK_BOTTOM - GameConstants.ENEMY_RADIUS)
			{
				return new Vector2(testPos.x, GameConstants.SIDEWALK_BOTTOM - GameConstants.ENEMY_RADIUS);
			}
			else if (testPos.y < GameConstants.SIDEWALK_TOP + GameConstants.ENEMY_RADIUS)
			{
				return new Vector2(testPos.x, GameConstants.SIDEWALK_TOP + GameConstants.ENEMY_RADIUS);
			}
			else
			{
				return testPos;
			}
		}
		
		public override function speedUp()
		{
			// Increase the speed
			velocity.multiply(GameConstants.HUMAN_SPEED_MULTIPLIER);
		}
		
		public override function hit() 
		{
			dodge();
		}
		
		public override function kill()
		{
			if (!(fsm.getCurrentState() is DeadState))
			{
				fsm.changeState(new DeadState(this));
				
				SoundManager.getInstance().playSound(SoundMappings.HUMAN_DEATH);
				SoundManager.getInstance().playSound(SoundMappings.APPLAUSE);
			}
		}
	}
}