﻿package 
{
	import flash.net.URLRequestMethod;
	public class GameConstants
	{
		// Frames per second
		public static const FPS:int = 30;
		
		// Size of the stage
		public static const STAGE_SIZE:Vector2 = new Vector2(640, 480);
		
		public static const SIDEWALK_TOP:int    = 195;
		public static const SIDEWALK_BOTTOM:int = 303;
		public static const ROAD_TOP:int = 87;
		public static const SIDEWALK_RANGE:int = SIDEWALK_BOTTOM - SIDEWALK_TOP;
		public static const ROAD_RANGE:int = SIDEWALK_TOP - ROAD_TOP;
		
		//constant used to clip the movealbe area of the player
		public static const BUILDING_EDGE:int = 40;
		
		// Size of the area in which enemies can spawn
		public static const PLAYABLE_STAGE_SIZE = new Vector2(640, STAGE_SIZE.y - 75);
		//Off stage buffer postions for spawning enemies
		public static const STAGE_LEFT:int  = -10;
		public static const STAGE_RIGHT:int = 650;
		public static const STAGE_LEFT_CAR:int  = -200;
		public static const STAGE_RIGHT_CAR:int = 840;
		
		// Acceleration due to gravity in m/(s^2)
		public static const GRAVITY:Number = 9.8;
		
		// Building height in meters
		public static const BUILDING_HEIGHT:Number  = 20;
		
		// The time need for an item to hit the ground
		public static const FALL_TIME:Number = Math.sqrt(BUILDING_HEIGHT * 2) / GRAVITY;
		
		// The number of frames before an item hits the ground
		public static const FALL_FRAMES:Number = FALL_TIME * FPS;
		
		// Scale by which falling objects change
		public static const ITEM_SCALE_FACTOR:Number = 0.96;
		
		// Number of frames an item stays on the ground before disappearing
		public static const GROUNDED_ITEM_LIFESPAN:Number = 80;
		public static const HUMAN_SPLATTER_LIFESPAN:Number = 160;
		
		// Number defining the odds of dodging a hit
		public static const ENEMY_DODGE_ODDS:Number = 0.5;
		
		// Maximum number of frames until another enemy is spawned
		public static const MAX_HUMAN_SPAWN_TIME:Number = 45;
		
		//Minimum numer of frames until another car is spawned
		public static const MIN_CAR_SPAWN_TIME:Number = 30;
		
		//Maximum numer of frames until another car is spawned
		public static const MAX_CAR_SPAWN_TIME:Number = 120;
		
		//Offset balloon from main character's center
		public static const BALLOON_OFFSET:int = 35;
		
		// Enemy movement speeds
		public static const ENEMY_WALKING_SPEED:Number    = 1;
		public static const ENEMY_DODGING_SPEED:Number    = 4;
		public static const ENEMY_SPRINTING_SPEED:Number  = 5;
		public static const ENEMY_PANIC_SPEED:Number      = 8;
		
		public static const HUMAN_SPEED_MULTIPLIER:Number = 2;
		public static const CAR_SPEED_MULTIPLIER:Number = 1.5;
		
		public static const HUMAN_DODGE_FRAMES:int = 20;
		public static const HUMAN_PAUSE_FRAMES:int = 75;
		
		public static const PLAYER_RADIUS:Number = 0;
		public static const ENEMY_RADIUS:Number  = 5;
		public static const ITEM_RADIUS:Number   = 10;
		
		//object directory
		public static const ASSET_DIR:String    = "./assets/";
		public static const OBJECT_DIR:String   = ASSET_DIR + "objects/";
		public static const SOUND_DIR:String    = ASSET_DIR + "sound/";
		public static const CUTSCENE_DIR:String = ASSET_DIR + "cutscenes/";
		
		// Car start positions and velocity
		public static const UPPER_LANE:int = 42;
		public static const LOWER_LANE:int = 132;
		public static const NORMAL_CAR_SPEED:int = 8;
		public static const SPORTS_CAR_START_SPEED:int = 6;
		
		public static const ENEMY_DODGE_RANGE:Number = Math.PI;
		public static const ENEMY_DODGE_START:Number = Math.PI;
		
		//layer index constants
		public static const LAYER:int = 2;
		
		public static const PANIC_RADIUS_BUF:int = 5;
		
		public static const PANIC_LENGTH:int = 15;
		
		public static const MAX_EXCITE:int = 10;
		
		public static const HITS_BEFORE_SWERVE:int = 3;
		
		public static const CAR_SWERVE_THETA:Number = 2;
		
		public static const SPORTS_CAR_DODGE_SPEED:Number = 20;
		
		public static const BEIGE_CAR_REVERSE_ACCEL:Number = 0.5;
		
		public static const RANK1:String = "Rank1.swf";
		public static const RANK2:String = "Rank2.swf";
		public static const RANK3:String = "Rank3.swf";
		public static const RANK4:String = "Rank4.swf";
		public static const RANK5:String = "Rank5.swf";
		public static const RANK6:String = "Rank6.swf";
	}
}