﻿package 
{
	import flash.display.MovieClip;
	import flash.display.Loader;
	import flash.net.URLRequest;
	import flash.events.Event;
	
	public class GameObject extends MovieClip
	{
		private var pos:Vector2;
		protected var theta:Number;
		
		protected var radius:Number;
		
		//variables for loading external asset
		private var animClip:MovieClip;		//container for animation clip
		private var isLoaded:Boolean;		//indicates if game object is fully loaded
		
		public function GameObject()
		{
			// Set a default position
			pos = new Vector2(0, 0);
			
			// Set the default theta
			theta = 0;
			
			// Set loading variables with default values
			animClip = null;
			isLoaded = false;
		}
		
		//function for loading asset to GameObject
		public function load( filepath:String ):void
		{
			var loader:Loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE,completeListener);
			loader.load(new URLRequest(filepath));
			
			this.addChild( loader );
		}
		
		//play animation within game object
		public function playAnimation( label:String ):void 
		{ 
			if ( this.isLoaded ) this.animClip.gotoAndPlay(label); 
			else trace("art not loaded");
		}
		
		//listen for game object to be completely loaded
		private function completeListener (e:Event):void 
		{ 
			//mark clip as completely loaded
			this.isLoaded = true;
			
			this.animClip = e.target.content.anim;
			
			var diagonal:Vector2 = new Vector2(e.target.width / 2, e.target.height / 2);
			radius = diagonal.length();
		}
		
		public function update():void
		{
		}
		
		public function setPos(pos:Vector2)
		{
			// Store the position
			this.pos = pos;
			
			// Set the MovieClip position
			this.x = pos.x;
			this.y = pos.y;
		}
		
		public function getPos():Vector2
		{
			return pos;
		}
		
		public function setTheta(theta:Number)
		{
			this.theta = theta;
			
			this.rotation = theta;
		}
		
		public function getTheta():Number
		{
			return theta;
		}
		
		public function getRadius():Number
		{
			return radius;
		}
	}
}