﻿package 
{
	public class Balloon extends Item
	{
		private var dTheta:Number = 20;
		
		public function Balloon()
		{
			super("Balloon.swf");
			
			this.scaleX = 0.6;
			this.scaleY = 0.6;
		}
		
		public function init(lifespan:int, startPos:Vector2, dest:Vector2):void
		{
			// Store the lifespan
			this.lifespan = lifespan;
			
			// Set the start position
			this.setPos(startPos);
			
			// Calculate and store the velocity
			velocity = new Vector2((dest.x - startPos.x) / lifespan, (dest.y - startPos.y) / lifespan);
		}
		
		public override function update():void
		{
			this.rotation += dTheta;
			
			this.setPos(Vector2.add(this.getPos(), velocity));
			
			this.scaleX *= GameConstants.ITEM_SCALE_FACTOR;
			this.scaleY *= GameConstants.ITEM_SCALE_FACTOR;
			
			lifespan--;
		}
	}
}