package
{
	import flash.display.MovieClip;
	
	import flash.ui.Mouse;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	public class MainManager extends MovieClip
	{
		private static var instance:MainManager
		
		private var intro:Intro;
		private var gameOver:GameOver;
		private var credits:Credits;
		
		private var game:Game;
		private var mainStage:MovieClip;
		
		public static var gameState:int;
		
		public function MainManager()
		{
			mainStage = this.MainStage;
			
			intro = new Intro();
			
			game = new Game(mainStage);
			
			init();
		}
		
		public function init():void
		{
			gameState = GameState.GAME_INTRO;
			
			mainStage.addChild(intro);
			
			SoundManager.getInstance().playBackgroundSound(SoundMappings.BACKGROUND_BEAT);
			
			mainStage.addEventListener(Event.ENTER_FRAME, OnEnterFrame);
			mainStage.addEventListener(MouseEvent.CLICK, OnMouseClick);
			
			intro.play();
		}
		
		public function endGame()
		{
			
		}
		
		public function showGameOver()
		{
			Mouse.show();
			
			gameOver = new GameOver();
			
			mainStage.removeChild(game);
			mainStage.addChild(gameOver);
		}
		
		public function reset()
		{	
			gameState = GameState.GAME_INTRO;
			
			mainStage.removeChild(credits);
			
			intro = new Intro();
			
			mainStage.addChild(intro);
			
			intro.play();
		}
		
		private function OnEnterFrame(event:Event):void
		{
			game.update();
			
			if (game.isGameOver() && gameState < GameState.GAME_OVER)
			{
				gameState = GameState.GAME_OVER;
				this.showGameOver();
			}
			
			if (gameState == GameState.GAME_OVER)
			{
				gameOver.update();
				
				if (gameOver.frame == 120)
				{
					gameOver.showScore(Game.killCount);
				}
			}
		}
		
		private function OnMouseClick(event:MouseEvent)
		{
			if (gameState == GameState.GAME_INTRO)
			{
				mainStage.removeChild(intro);
				Mouse.hide();
				mainStage.addChild(game);
				gameState = GameState.GAME_PLAY;
				game.startGame();
			}
			else if (gameState == GameState.GAME_OVER)
			{
				if ((mouseX >= 125 && mouseX <= 270) && (mouseY >= 410 && mouseY <= 448))
				{
					mainStage.removeChild(gameOver);
					Mouse.hide();
					mainStage.addChild(game);
					gameState = GameState.GAME_PLAY;
					game.reset();
					game.startGame();
					gameOver.hideScore();
				}
				if ((mouseX >= 372 && mouseX <= 538) && (mouseY >= 416 && mouseY <= 455))
				{
					mainStage.removeChild(gameOver);
					
					credits = new Credits();
					
					mainStage.addChild(credits);
					gameState = GameState.GAME_CREDITS;
					gameOver.hideScore();
					game.reset();
				}
			}
			else if (gameState == GameState.GAME_CREDITS)
			{
				gameState = GameState.GAME_INTRO;
				game.reset();
				reset();
			}
		}
	}
}